addhook("startround","shd_roundstart")
addhook("use","shd_use")
addhook("hitzone","shd_hitzone")
addhook("movetile","shd_movetile")

parse("restart")

shd = {}
shd.tileVar = {}
shd.tileVarb = {}
shd.shield = {}
shd.shieldbool = {}

function shd_roundstart()
	for x = 0, map'xsize' do
		shd.tileVar[x] = {}
		shd.tileVarb[x] = {}
		shd.shield[x] = {}
		shd.shieldbool[x] = {}
		for y = 0, map'ysize' do
			if entity(x,y,"typename") == "Trigger_Use" then
				if entity(x,y,"name") == "shield" then
					shd.shield[x][y] = 0
					shd.shieldbool[x][y] = false
					if tile(x,y,"walkable") == true then
						shd.tileVar[x][y]=image("gfx/pseudon/entity01/device.bmp",x * 32 + 16,y * 32 +16,0)
					else
						shd.tileVar[x][y]=image("gfx/pseudon/entity01/device.bmp",x * 32 + 16,y * 32 +16,3)
					end
					shd.tileVarb[x][y]=image("gfx/pseudon/entity01/deviceshade.bmp",x * 32 + 32,y * 32 + 32,0)
					imageblend(shd.tileVarb[x][y],2)
				end
			end
		end
	end
end

function shd_use(user,event,data,x,y)
	if event == 100 then
		if entity(x,y,"typename") == "Trigger_Use" then
			if entity(x,y,"name") == "shield" then
				if shd.shieldbool[x][y] == false then
					shd.shield[x][y]=image("gfx/pseudon/entity01/shield.bmp",x * 32 + 16,y * 32 + 16,3)
					imageblend(shd.shield[x][y],1)
					imagecolor(shd.shield[x][y],125,200,100)
					tween_rotateconstantly(shd.shield[x][y],25)
					imagehitzone(shd.shield[x][y],101,-16,-16,33,33)
					shd.shieldbool[x][y] = true
					for _,id in pairs(player(0,"table")) do
						if player(id,"tilex") == x then
							if player(id,"tiley") == y then
								parse("customkill "..user.." Electrified "..id)
							end
						end
					end
				elseif shd.shieldbool[x][y] == true then
					freeimage(shd.shield[x][y])
					shd.shieldbool[x][y] = false
				end
			end
		end
	end
end

function shd_hitzone(iid,id,oid,w,x,y,d)
	xe = x / 32
	ye = y / 32
	local x3, x2 = math.modf(xe)
	local y3, y2 = math.modf(ye)
	if iid == shd.shield[x3][y3] then
		parse("effect \"flare\" "..x.." "..y.." 1 1 100 200 100")
	end
end

function shd_movetile(id,x,y)
	if entity(x,y,"typename") == "Trigger_Use" then
		if shd.shieldbool[x][y] == true then
			parse("customkill "..id.." Electrified "..id)
		end
	end
end